function cat_scan, ns, nl, nb, in_fid


status_string_array = ['Seperating features from noise']
envi_report_init, status_string_array, base = status_base, title = 'CAT_scan Feature Finder', /interupt
envi_report_inc, status_base, nl

; Make all-bands vector for POS keyword on get_slice; probably not necessary, 
; as written in_pos is undefined and envi_get_slice probably returns all bands by 
; default. But be safe... (FM, Oct 2009)
pos_all_bands = lindgen(nb)

Terrain = fltarr(ns, nl)
Atmo_Spec = fltarr(nb)
for j=0, nl-1 do begin 

  ;Progress Bar Update
  envi_report_stat, status_base, j, nl, cancel=cancel
  if (cancel) then begin
       print, 'Despike->CatScan: Cancel'
       envi_report_init, base = status_base, /finish
    return,{Atmo_Spec:-1}
  endif

  ; Replace POS=in_pos (undefined) with POS=pos_all_bands (FM, Oct 2009)
  image_in = ENVI_GET_SLICE(/bil, FID=in_fid, LINE=j, POS=pos_all_bands, XS=0, XE=ns-1)  ;spectral by x

  bad = where(image_in gt 1 or image_in lt -1)
  if(bad[0] ne -1) then $
    image_in[bad] = 0

  ;Compressing in lambda gives you a map of the terrain features
  Terrain[*,j] = TOTAL( image_in, 2, /NAN, /PRESERVE_TYPE )/nb
  
  ;Similarly, the cube can be compressed to yield an average spectrum
  ;This is not intended to compensate for terrain variability, but rather wash out
  ;the dominant, sharp atmospheric bands which can be confused with spikes

  ;this technically does not 'normalize' the data, because the sample size is no longer ns,
  ;however it's only important that it be accurate up to a scale factor, since it will be added back in
  Atmo_Spec = TOTAL( image_in, 1, /NAN, /PRESERVE_TYPE )/float(ns)   +   Atmo_Spec
endfor

Atmo_Spec = Atmo_Spec/float(nl)  ;the normalization is done in 2 steps to reduce round-off error

envi_report_init, base = status_base, /finish       

filter = {Atmo_Spec:Atmo_Spec, Terrain:Terrain}
return, filter
end