function cat_strip_quotes, instr

; Strip any double or single quotes out of an input string.
;
; Returns string(instr) if input not string type.
;
; (Expected use: label file read might return sensor ID with quotes 
; and you can use this routine to strip them and leave L instead of "L"
; for example.)


if (size(instr,/type) ne 7) then return, string(instr)
if (strlen(instr) eq 0) then return,''
b = byte(instr)
b_dbl = byte('"')     ; ascii for double quote
b_sin = byte("'")     ; ascii for single quote
k = where(((b ne b_dbl[0]) and (b ne b_sin[0])), nk)
if (nk eq 0) then return,''
return, string(b[k])
end
