function cat_auxfile_path

; Return aux_file path, from config file if specified, default if not.
; Includes terminating path separator.

forward_function get_catcfg_param, envi_get_configuration_values

auxpath = get_catcfg_param('CAT_AUXFILES_PATH')
if (~file_test(auxpath)) then begin
	; Try to get if from ENVI config, assuming 'aux_files' parallel to 'save_add'
	psep = path_sep()
	ecv = envi_get_configuration_values()
	tn = strlowcase( strtrim(tag_names(ecv),2) )
	k = where((tn eq 'default_save_add_directory'), nk)
	if (nk eq 1) then begin
		saveadd_path = ecv.(k[0])
		p = strpos(strupcase(saveadd_path), psep+'SAVE_ADD', /reverse_search)
		auxpath = strmid(saveadd_path, 0, p+1) + 'aux_files' + psep
	endif

	; Check again in case config-derived path still's no good
	if (~file_test(auxpath)) then begin
		; Nope, still no good; try crudest default possible
		if (strpos(strupcase(!version.os_family), 'WIN') ge 0) then begin
			auxpath = 'C:\Program Files\CAT_ENVI\aux_files\'
		endif else begin
			auxpath = '~/CAT_ENVI/aux_files/'
		endelse
	endif
endif

; Final check: 
if (~file_test(auxpath)) then return,''

; Make sure ends with path separator:
psep = path_sep()
auxpath = strtrim(auxpath,2)
if (strmid(auxpath, strlen(auxpath)-1, 1) ne psep) then auxpath += psep

return, auxpath
end
