;******************************************************************************
;
; function missionday_from_date, date_dom1, this_date
;
; Day of mission from date yyyy_ddd. 
;
; INPUT:
;	date_dom1    string   Date yyyy_ddd on mission day 1.
;	this_date    string   Date, yyyy_mmm
;
; OUTPUT PARAMETERS: None
;
; RETURN VALUE:
;	Integer value = day of mission from yyyy_ddd.
;
; KEYWORDS: None.
;
; NOTES:
;	cat_days_in_year
;
; USES:
;	cat_days_in_year
;
; HISTORY:
;	2009 Mar 25 F. Morgan: First version written. Tested 4/2.
;
;******************************************************************************

function missionday_from_date, date_dom1, this_date

forward_function cat_days_in_year

d1 = strtrim(date_dom1,2)
start_year = fix(strmid(d1,0,4))
start_day = fix(strmid(d1,5,3))

d = strtrim(this_date,2)
end_year = fix(strmid(d,0,4))
end_day = fix(strmid(d,5,3))

dom = 1
doy1 = start_day
for this_year=start_year,end_year-1 do begin
	dom += cat_days_in_year(this_year) + 1 - doy1
	doy1 = 1
endfor
dom += end_day-doy1

return,dom
end

