pro bin6w,  name,head,aa
; write binary files with 'standard' header
;_args
; name	 !i. file name
; header !i. string text to insert in header (keep < 404 bytes for 4-D array)
; aa	 !i. array to write
;_desc  this routine matched with  bin5r
;
; USAGE
; bin5w, file_name, descriptive_text, array_to_write
;
;_hist  97apr27 Hugh Kieffer 98mar15 revise header handling
; 98may08  add record of byte architecture
; 98jul02  TNT added ability to handle strings.
; 98jul06  TNT added the ability to handle structures.
;
;_bugs  98jul06  TNT when using strings inside of structures, you must ensure
;		that the strings are all the same length.
;_end

headlen = 512L			; total length of header
get_lun, iod			; select a logical unit
openw, iod,name,error=operr	; open the binary file
if operr ne 0 then begin
	print,'BIN5W: open ERROR # and file=',operr,name,strmessage(operr) 
	free_lun,iod            ; free up the logical unit
	return
	endif

;construct header
ss=sizex(aa)			; get the array size and type
aaa=aa
if ss(ss(0)+1) eq 7 then if min(strlen(aa)) ne ss(ss(0)+2) then $
	aaa=strmid(aa+string(bytarr(ss(ss(0)+2))+32b),0,ss(ss(0)+2)) else $
	aaa=aa
ndim=ss(0)			; number of dimensions
hh = string(ss(0))		; write number of dimensions at start of header
for i=1,n_elements(ss)-1 do  hh=hh+string(ss(i)) ; add the remaining sizes
if ss(ss(0)+1) eq 8 then begin
	tags=tag_names(aaa)
	hh=hh+'{'
	for i=0,n_tags(aaa)-1 do hh=hh+tags(i)+string(9b)
	strput,hh,'}',strlen(hh)-1
	endif
ih=hh+string(headlen)+' <<idl_SIZE '+SYSTIME(0)+' >> '+ head
j=strlen(ih)			; get current header length
headlen=(1+(j+10)/512)*512	; increase header length to multiple of 512.
hh=hh+string(headlen) 
hh = hh+' <<idl_SIZE '+SYSTIME(0)+' >> '+ head 	; add the time and input text
hh=hh+string(bytarr(headlen-j)+32b)	;extend header to fixed length
arch=!version.arch
strput,hh,arch,headlen-10	; write hardware architecture in fixed location
strput,hh,'C_END',headlen-5	; write standard "end" to header
bb=byte(hh) ;  & help,bb
writeu,iod, bb,aaa		; write the header & array

done: ;===================== DONE =====================
free_lun,iod                    ; free up the logical unit
return
end
pro bin6w,  name,head,aa
; write binary files with 'standard' header
;_args
; name	 !i. file name
; header !i. string text to insert in header (keep < 404 bytes for 4-D array)
; aa	 !i. array to write
;_desc  this routine matched with  bin5r
;
; USAGE
; bin5w, file_name, descriptive_text, array_to_write
;
;_hist  97apr27 Hugh Kieffer 98mar15 revise header handling
; 98may08  add record of byte architecture
; 98jul02  TNT added ability to handle strings.
; 98jul06  TNT added the ability to handle structures.
;
;_bugs  98jul06  TNT when using strings inside of structures, you must ensure
;		that the strings are all the same length.
;_end

headlen = 512L			; total length of header
get_lun, iod			; select a logical unit
openw, iod,name,error=operr	; open the binary file
if operr ne 0 then begin
	print,'BIN5W: open ERROR # and file=',operr,name,strmessage(operr) 
	free_lun,iod            ; free up the logical unit
	return
	endif

;construct header
ss=sizex(aa)			; get the array size and type
aaa=aa
if ss(ss(0)+1) eq 7 then if min(strlen(aa)) ne ss(ss(0)+2) then $
	aaa=strmid(aa+string(bytarr(ss(ss(0)+2))+32b),0,ss(ss(0)+2)) else $
	aaa=aa
ndim=ss(0)			; number of dimensions
hh = string(ss(0))		; write number of dimensions at start of header
for i=1,n_elements(ss)-1 do  hh=hh+string(ss(i)) ; add the remaining sizes
if ss(ss(0)+1) eq 8 then begin
	tags=tag_names(aaa)
	hh=hh+'{'
	for i=0,n_tags(aaa)-1 do hh=hh+tags(i)+string(9b)
	strput,hh,'}',strlen(hh)-1
	endif
ih=hh+string(headlen)+' <<idl_SIZE '+SYSTIME(0)+' >> '+ head
j=strlen(ih)			; get current header length
headlen=(1+(j+10)/512)*512	; increase header length to multiple of 512.
hh=hh+string(headlen) 
hh = hh+' <<idl_SIZE '+SYSTIME(0)+' >> '+ head 	; add the time and input text
hh=hh+string(bytarr(headlen-j)+32b)	;extend header to fixed length
arch=!version.arch
strput,hh,arch,headlen-10	; write hardware architecture in fixed location
strput,hh,'C_END',headlen-5	; write standard "end" to header
bb=byte(hh) ;  & help,bb
writeu,iod, bb,aaa		; write the header & array

done: ;===================== DONE =====================
free_lun,iod                    ; free up the logical unit
return
end
